'
' FILE: EFTExport.vbs
' CREATED: 10 JAN 2008 GTH/ PPK
' PURPOSE: To export EFT VFS permissions in text file 

Option Explicit
Dim oArgs
Dim strHost, strLogin, strPassword, strTextFile, strSite, strPort
Dim strFolder, strParentFolder, strFolderList, strAccess, strSkipLines
Dim oSFTPServer, oSites, oSite
Dim g_sOutPut, g_strVFSBuffer 

'==============================================================================
'
' Main
'
'==============================================================================
If (ProcessArgs=-1) then wscript.quit

WScript.Echo  "Runtime Parameters:" & vbCrLf & "-------------------" & vbCrLf & _
             "strHost = " & strHost & vbCrLf & _
			 "strPort = " & strPort & vbCrLf & _
             "Login   = " & strLogin & vbCrLf & _
             "Password= " & strPassword & vbCrLf & _
			 "strSite = " & strSite & vbCrLf & _
             "CSVFile = " & strTextFile & vbCrLf & _
			 ":"
g_strVFSBuffer= ""			 
Call ConnectAndLogin()
call createVFSTree("/")
call ImportDataToTextFile ()

'==============================================================================
' This method connectst to the specified EFT server and attempts to
' log in using the supplied information.
'==============================================================================
Sub ConnectAndLogIn()
Dim WshShell
	' Let's check to be sure we can connect to the specified EFT Server:
	WScript.Echo "<CONNECTING TO SERVER>"
	WScript.Echo Chr(9) & "Connecting to " & strLogin & "@" & strHost & ":1100 [Site " & strSite & "]"
	Set oSFTPServer = WScript.CreateObject("SFTPCOMInterface.CIServer")
	' NOTE we assume default ADMIN port of 1100 -- please chang this if you have
	' manually configured your EFT to be different.
	On Error Resume Next
	oSFTPServer.Connect strHost, CLng(strPort), strLogin, strPassword

	If Err.Number <> 0 Then
	   WScript.Echo Chr(9) & "Error connecting to '" & strHost & ":" & 1100 & "' -- " & err.Description & " [" & CStr(err.Number) & "]", vbInformation, "Error"
	   WScript.Echo Chr(9) & "Attempting to restart service..."
	   err.Clear
	   Set WshShell = WScript.CreateObject("WScript.Shell")
	   call WshShell.Run("net start ""globalscape eft server""", 1, true)
	   Set WshShell = nothing
	   WScript.Echo Chr(9) & "Waiting for 5 seconds for the service to initiate..."
	   WScript.Sleep 5000
		WScript.Echo Chr(9) & "Connecting to " & strLogin & "@" & strHost & ":1100 [Site " & strSite & "]"
	   oSFTPServer.Connect strHost, CLng(strPort), strLogin, strPassword
	   If Err.Number <> 0 Then
	   	WScript.Echo Chr(9) & "Error connecting to '" & strHost & ":" & 1100 & "' -- " & err.Description & " [" & CStr(err.Number) & "]", vbInformation, "Error"
	   	WScript.Quit 253
	   Else
	   	WScript.Echo Chr(9) & "Connected to " & strHost
           end if
	End If
	On Error GoTo 0  ' resume error trapping
	set oSites=oSFTPServer.Sites
	Dim iCount	
	For iCount=0 to oSites.count - 1
		Set oSite = oSites.Item(iCount)
		if LCase(Trim(oSite.Name)) = LCase(Trim(strSite)) then
			exit for
		End if
	Next	
	WScript.Echo Chr(9) & "Connected to site '" & oSite.Name & "'" & vbCrLf

End Sub

'Checks whether the folder has subfolder or not.
'If the  folder has "" appended to it then it contains the sub folder
'
function hasSubFolders(ByVal sFolderName)
	if sFolderName <> "" then
		if Right(sFolderName, 1) = """" then
			hasSubFolders = true
		end if
	end if
End function

Function StripVirtualPortion(ByVal sPath)
	
	Dim iPos , sVirtualFolderPath,bIsVirtual
	
	iPos = InStr(1, sPath, " - Virtual", 1 )
	If ( iPos > 0 ) Then
		WScript.Echo "-->Stripping VIRTUAL portion of folder name"
		sVirtualFolderPath = sPath
		sPath = Left( sPath, iPos -1 ) & "/"
	End If
	
	StripVirtualPortion = sPath
End Function
'==============================================================================
'This recursive function is used to iterate through the VFS Tree and
'	generated corresponding CSV file 
'==============================================================================
function createVFSTree(ByVal sPath)
	Dim aPerms
	Dim sFolderList, arFolderList, iFolder, sTempPath 
	Dim sFolder, SFolderPath
	Dim bIsVirtual : bIsVirtual = True
	Dim bHasSubFolders

	'Empty the Output String to prepare for the new output
	g_sOutput = ""
	
	'Strip the original path of the 'Virtual' word and
	'Get the folder permisssions for the given path
	Dim strPath
	strPath	= StripVirtualPortion(sPath)
	aPerms = oSite.GetFolderPermissions (strPath)
	'Store the permissions for the folder 
	Call StorePermissions (aPerms, sPath)

	'Get sub folder list for the given path
	sFolderList		= oSite.GetFolderList (strPath)	
	'Split the folder list into seperate sub folder names and store in arFolderList
	arFolderList	= Split (sFolderList, vbCrLf)
	
	For iFolder = 0 To UBound (arFolderList) - 1
		'Retrieve one folder from the folder list for processing
		sFolder		= arFolderList (iFolder)
		
		'Does the folder have sub folders??
		bHasSubFolders = hasSubFolders (sFolder)

		If bHasSubFolders Then										'If yes then 
			sFolder = left(sFolder, len(sFolder) - 1)				'Remove the " indicating subfolder present
			
			sTempPath = strPath & sFolder  & "/"'Append a / to the end of the folder path (for normal folder)
			Call CreateVFSTree(sTempPath)							'Recursive call to process this folder with sub folders
		Else														'If no-sub folders then	
																	'Strip the virtual word from the path if the folder is a virtual folder
			sFolderPath = strPath & StripVirtualPortion (sFolder)		'Create the folder path Strip both sPath and sFolder as it may contain - Virtual
			aPerms = oSite.GetFolderPermissions(sFolderPath)		'Get Permissions on the folder path created
			Call StorePermissions(aPerms, strPath & sFolder & "/")			'Call StorePermission on the folder path
		End if
	Next
End Function

'User-defined IIf function to perform ternary operation i.e. expression? true_value : false_value
Function IIf(bCondition, sTrueValue, sFalseValue)
	if bCondition Then
		If IsObject(sTrueValue) Then
			Set IIf = sTrueValue
		Else
			IIf = sTrueValue
		End If
	Else
		If IsObject(sFalseValue) Then
			Set IIf = sFalseValue
		Else
			IIf = sFalseValue
		End If
	End If
End Function

function StorePermissions(arPerms, strFullFolderPath)
	Dim iCount, oPermission
	Dim sPath

	WScript.Echo "Exporting data for folder " & strFullFolderPath
	
	For iCount = LBound(arPerms) To UBound(arPerms)
		Set oPermission = arPerms (iCount)
				 
		sPath = StripVirtualPortion(strFullFolderPath)
		
		'If the current folder if the root folder Or
		'If the folder path length matches that of the "inherited from" path 
		'(means that personal permissions are set on the folder for this group and inherit status is not set)
		If  (sPath = "/" Or (len(sPath) = Len (oPermission.Folder)))  then
			
			'Append permissions group name
			g_sOutPut = g_sOutPut & strFullFolderPath & ","
			g_sOutPut =  g_sOutPut & oPermission.Client & ","
			
			'Append folder permissions
			g_sOutPut =  g_sOutPut & IIf(oPermission.FileUpload,	"U", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.FileDownload,	"D", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.FileAppend,	"A", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.FileDelete,	"D", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.FileRename,	"R", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirShowinList, "S", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirCreate,		"C", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirDelete,		"D", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirList,		"L", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirShowHidden,	"H", "-")
			g_sOutPut =  g_sOutPut & IIf(oPermission.DirShowReadOnly,"O", "-")
			g_sOutPut =  g_sOutPut & ","

			'Append "Inherited from" foldername
			g_sOutPut =  g_sOutPut & oPermission.Folder

			WScript.Echo g_sOutPut
			g_strVFSBuffer = g_strVFSBuffer & g_sOutPut &vbCrLf
			g_sOutPut = ""
		Else
			'In case of virtual folder with inheritance set to true
			'The above logic fails to make an entry into the back up permissions file
			'So handle the virtual folder case here

			 'If the folder is a virtual folder and if the folder entry is not found in the global buffer
			If InStr(1,strFullFolderPath, "- Virtual", 1 ) > 0 And InStr (1, g_strVFSBuffer, strFullFolderPath, 1) = 0 Then	
				WScript.Echo "Found a virtual folder " + strFullFolderPath + " with inherited group permission. Adding a blank entry"
				g_strVFSBuffer = g_strVFSBuffer & strFullFolderPath &",,," & vbCrLf
			End If

		End If
	Next 
end function
'==============================================================================
'
'   ProcessArgs
'
'   Parse the command-line arguments.  Results are set in global variables
'   (strHost, strLogin, strPassword, strTextFile, bHomeDirIsRoot, arStripPaths, bStripPaths ).
'
'==============================================================================
public function ProcessArgs
    Dim iCount
    Dim oArgs

    on error resume next

	' Default our arguments.  Some are required.
	strHost = ""
	strLogin = ""
	strPassword = ""
	strPort = "1100"
	strSite = ""
	strTextFile=""
    ' Get the command-line arguments
    '
    Set oArgs = WScript.Arguments
    if oArgs.Count > 0 then
		' We have command-line arguments.  Loop through them.
		iCount = 0
		ProcessArgs = 0

		do while iCount < oArgs.Count

			select case oArgs.Item(iCount)
				'
				' Server name argument
				'
				case "-s"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strHost = oArgs.Item(iCount+1)
					iCount = iCount + 2

				'
				' What port to connect to for EFT server. Default to 1100
				'
				case "-port"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strPort = oArgs.Item(iCount+1)
					iCount = iCount + 2

				'
				' admin login name argument
				'
				case "-u"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strLogin = oArgs.Item(iCount+1)
					iCount = iCount + 2

				'
				' admin password argument
				'
				case "-p"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strPassword = oArgs.Item(iCount+1)
					iCount = iCount + 2

				'
				' Which site to look into.  Defaults into 1.
				'
				case "-site"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strSite = oArgs.Item(iCount+1)
					iCount = iCount + 2

				'
				' CSVFile name argument
				'
				case "-f"
					if( iCount + 1 >= oArgs.Count ) then
						Syntax
						ProcessArgs = -1
						exit do
					end if

					strTextFile = oArgs.Item(iCount+1)
					iCount = iCount + 2
				'
				' Help option
				'
				case "-?"
					Syntax
					ProcessArgs = -1
					exit function
				'
				' Invalid argument
				'
				case else
				' Display the syntax and return an error
					wscript.echo "Unknown argument: " & oArgs.Item(iCount) & vbCrLf
					Syntax
					ProcessArgs = -1
					Exit function
			end select
		loop
	Else
		'
		' There were no command-line arguments, display the syntax
		' and return an error.
		'
		Syntax
		ProcessArgs = -1
	End if

	Set oArgs = Nothing

	If ( strHost = "" OR strLogin = "" or strSite = "" or strPassword = "" or strTextFile = "" ) Then
		Syntax
		ProcessArgs = -1
	End If

End function ' ProcessArgs
'==============================================================================
'   Syntax
'   Show the command-line syntax
'==============================================================================
public function Syntax
	wscript.echo    vbCrLf & _
		"Purpose:   Export VFS tree permissions to a text file " & vbCrLf & _
		"Usage:     " & wscript.scriptname & " <arguments>" & vbCrLf & _
		"Required Arguments:" & vbCrLf & _
		"     -s EFT Server" & vbCrLf & _
		"     -u Admin username for EFT Server" & vbCrLf & _
		"     -p Admin password" & vbCrLf & _
		"     -site   which Site ID on the server we are manipulating. Defaults to 0" & vbCrLf & _
		"     -f Path of text file to store data " & vbCrLf & _
		vbCrLf & _
		"Optional Arguments: " & vbCrLf & _
		"     -? This help" & vbCrLf & _
		"     -port   admin port on EFT server. Defaults to 1100" & vbCrLf & _
		"Example:   " & wscript.scriptname & "  -s localhost -port 1100 -u admin -p secret -site SiteName -f c:\migrate.txt" 

end function    ' Syntax

Sub ImportDataToTextFile()
	'Open text file to import teh data 
	Dim oFSO, oFile
	Set oFSO = CreateObject("Scripting.FileSystemObject")
	Set oFile = oFSO.CreateTextFile( strTextFile, True )  
	oFile.WriteLine(g_strVFSBuffer)
	oFile.Close
End Sub
